% problem definition
% minimize E= 0.5 x^T w x, with x=x_1,...,x_n and x_i=0,1
% w is a symmetric real n x n matrix with zero diagonal

METHOD='sa';
NEIGHBORHOODSIZE=1;
n_restart =100;

switch METHOD,
case 'iter'
	% set number of restarts

	E_min = 1000;
	for t=1:n_restart,

	% initialize
	x = 2*(rand(1,n)>0.5)-1;
	E1 = E(x,w);
	flag = 1;

	while flag == 1,
		flag = 0;
		switch NEIGHBORHOODSIZE,
		case 1,
			% choose new x by flipping one bit i
			for i=1:n,
				[dE1,flag]=dE_1(i,x,w);
				if flag 
					x(i)=-x(i); 
					E1 = E1 + dE1;
				end;
			end;
		case 2,
			% choose new x by flipping bits i,j
			for i=1:n,
			for j=i+1:n,
				[dE1,flag]=dE_2(i,j,x,w);
				if flag 
					x(i)=-x(i); 
					x(j)=-x(j);
					E1 = E1 + dE1;
				end;
			end;
			end;
		end;
	end;
	E_min = min(E_min,E1);
	[E_min, E1]
	end;
case 'sa'
	% initialize
	x = 2*(rand(1,n)>0.5)-1;
	E1 = E(x,w);

	% initialize temperature
	max_dE=0;
	switch NEIGHBORHOODSIZE,
        case 1,
			for i=1:n,
            	[dE1,flag]=dE_1(i,x,w);
				max_dE=max(max_dE,dE1);
			end;
        case 2,
			for i=1:n,
			for j=i+1:n,
            	[dE1,flag]=dE_2(i,j,x,w);
				max_dE=max(max_dE,dE1);
			end;
			end;
        end;
	beta_init=1/max_dE;
	T1=1000; % length markov chain at fixed temperature
	factor=1.05 ; % increment of beta at each new chain

	beta=beta_init;
	E_bar(1)=1;
	t2=1;
	while E_bar(t2) > 0,
		t2=t2+1;
		beta=beta*factor;
		E_all=[];
		for t1=1:T1,
			switch NEIGHBORHOODSIZE,
			case 1,
				% choose new x by flipping one bit i
				i=ceil(rand*n);
				[dE1,flag]=dE_1(i,x,w);
				if (flag | (rand<exp(-beta*dE1)))
					x(i)=-x(i); 
					E1 = E1 + dE1;
				end;
			case 2,
				% choose new x by flipping bits i,j
				i=ceil(rand*n);
				j=ceil(rand*(n-1));
				if (j >= i) j=j+1; end;
				[dE1,flag]=dE_2(i,j,x,w);
				if (flag | (rand<exp(-beta*dE1)))
					x(i)=-x(i); 
					x(j)=-x(j);
					E1 = E1 + dE1;
				end;
			end;
			E_all=[E_all, E1];
		end;
		E_outer(t2)=mean(E_all);
		E_bar(t2)=std(E_all);
		[t2 beta E_outer(t2) E_bar(t2)]
	end;
end;
